.386p

public install_ext21

code32 segment public use32 'code'
assume cs:code32,ds:code32

ext21_oldint21_o dd 0
ext21_oldint21_s dw 0

xferbuffer dd 0
xferseg    dw 0

install_ext21:
   mov ax,0ee02h
   int 31h
   mov xferseg,ax
   movzx eax,ax
   shl eax,4
   sub eax,ebx
   mov xferbuffer,eax

   mov bl,21h
   mov ax,204h
   int 31h
   mov ext21_oldint21_o,edx
   mov ext21_oldint21_s,cx

   mov bl,21h
   mov ax,205h
   mov cx,cs
   mov edx,offset ext21
   int 31h
ret

ext21:
; functions to be implemented? 47 , 4b , 4e , 56 , 5a
 cmp ah,39h                          ; Create dir
 je ext21_carryspawner_string
 cmp ah,3ah                          ; Remove dir
 je ext21_carryspawner_string
 cmp ah,3bh                          ; Change dir
 je ext21_carryspawner_string
 cmp ah,3ch                          ; Create file
 je ext21_carryspawner_string
 cmp ah,3dh                          ; Open file
 je ext21_carryspawner_string
 cmp ah,41h                          ; Delete file
 je ext21_carryspawner_string
 cmp ah,5bh                          ; New file
 je ext21_carryspawner_string

 cmp ah,43h
 je ext21_carryspawner_string2       ; Get/Set file attribs

 cmp ah,3fh                          ; Read from file
 je ext21_readwrite
 cmp ah,40h                          ; Write to file
 je ext21_readwrite

 cmp ah,42h                          ; Seek file
 je ext21_lseek

; Chain
 db 0ffh,02dh
 dd offset ext21_oldint21_o

ext21_ascizcopy:
   ext21_ascizcopy_loop:
    lodsb
    stosb
    cmp al,0
    je short ext21_ascizcopy_loop_endloop
   loop ext21_ascizcopy_loop
   ext21_ascizcopy_loop_endloop:
 ret

ext21_lseek:
  pushad
   mov ext21_eax,eax
   mov ext21_ebx,ebx
   mov ext21_edx,edx
   shr edx,16
   mov ext21_ecx,edx
   mov ax,0300h
   mov ecx,0
   mov bx,21h
   mov edi,offset ext21_regstruc
   int 31h
   mov eax,ext21_edx
   mov word ptr[ext21_eax+2],ax
  popad
  mov ax,ext21_flags
  and dword ptr[esp+8],0fffffffeh
  and eax,01h
  or dword ptr[esp+8],eax
  mov eax,ext21_eax
 iretd

ext21_string_common:
  pushad
   mov ext21_eax,eax
   mov ext21_ecx,ecx
   mov ext21_ebx,ebx
   mov esi,edx
   mov edi,xferbuffer
   mov ecx,8192
   call ext21_ascizcopy
   mov ax,xferseg
   mov ext21_ds,ax
   mov ext21_edx,0

   mov ax,0300h
   mov bx,21h
   mov ecx,0
   mov edi,offset ext21_regstruc

   int 31h
  popad
ret

ext21_carryspawner_string:
  call ext21_string_common
  mov ax,ext21_flags
  and dword ptr[esp+8],0fffffffeh
  and eax,01h
  or dword ptr[esp+8],eax
  mov eax,ext21_eax
 iretd

ext21_carryspawner_string2:
  call ext21_string_common
  mov ax,ext21_flags
  and dword ptr[esp+8],0fffffffeh
  and eax,01h
  or dword ptr[esp+8],eax
  mov eax,ext21_eax
  mov ecx,ext21_ecx
 iretd


ext21_bytes_transfered dd 0
ext21_operation        dd 0
ext21_pointer          dd 0
ext21_size             dd 0
ext21_handle           dd 0
ext21_bcz              dd 0

ext21_readwrite:
 pushad
  mov ext21_bytes_transfered,0
  mov ext21_operation,eax
  mov ext21_pointer,edx
  mov ext21_size,ecx
  mov ext21_handle,ebx
  ext21_readwrite_loop:

   mov ecx,ext21_size
   cmp ecx,8192
   jb ext21_readwrite_loop_1
    mov ecx,8192
   ext21_readwrite_loop_1:

   sub ext21_size,ecx
   call ext21_block

   test ext21_flags,1
   jnz ext21_readwrite_loop_err

    movzx eax,word ptr[ext21_eax]
    add ext21_bytes_transfered,eax

    add ext21_pointer,ecx

    cmp eax,ecx
    jne ext21_readwrite_loop_end

  cmp ext21_size,0
  jne ext21_readwrite_loop
  ext21_readwrite_loop_end:

 popad
 and dword ptr[esp+8],0fffffffeh
 mov eax,ext21_bytes_transfered
iretd

ext21_readwrite_loop_err:
 popad
 or dword ptr[esp+8],1
 mov ax,word ptr[ext21_eax]
iretd

ext21_block:
  pushad
   mov ext21_ecx,ecx
   mov ext21_bcz,ecx
   mov esi,ext21_pointer
   mov edi,xferbuffer
   cmp ecx,0
   je ext21_block_not
    rep movsb
   ext21_block_not:
   mov ebx,ext21_handle
   mov ext21_ebx,ebx
   mov eax,ext21_operation
   mov ext21_eax,eax
   mov ax,xferseg
   mov ext21_ds,ax
   mov ext21_edx,0
   mov ax,300h
   mov ecx,0
   mov ebx,21h
   mov edi,offset ext21_regstruc

   int 31h
   cmp byte ptr[ext21_operation+1],3fh
   je ext21_block_copyback
  popad
ret

ext21_block_copyback:
   mov ecx,ext21_bcz
   mov esi,xferbuffer
   mov edi,ext21_pointer
   cmp ecx,0
   je ext21_block_not_copyback
    rep movsb
   ext21_block_not_copyback:
  popad
ret

ext21_regstruc: 
ext21_edi   dd 0
ext21_esi   dd 0
ext21_ebp   dd 0
ext21_res   dd 0   ; Esp, IGNORE
ext21_ebx   dd 0
ext21_edx   dd 0
ext21_ecx   dd 0
ext21_eax   dd 0
ext21_flags dw 0
ext21_es    dw 0
ext21_ds    dw 0
ext21_fs    dw 0
ext21_gs    dw 0
ext21_ip    dw 0
ext21_cs    dw 0
ext21_sp    dw 0
ext21_ss    dw 0

code32 ends
end
